"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.parseSignature = exports.parsePublicKey = void 0;
const asn1js_1 = require("asn1js");
function toArrayBuffer(buffer) {
    const ab = new ArrayBuffer(buffer.length);
    const view = new Uint8Array(ab);
    for (let i = 0; i < buffer.length; ++i) {
        view[i] = buffer[i];
    }
    return ab;
}
function parsePublicKey(buf) {
    const { result } = (0, asn1js_1.fromBER)(toArrayBuffer(buf));
    const values = result.valueBlock.value;
    const value = values[1];
    return Buffer.from(value.valueBlock.valueHex.slice(1));
}
exports.parsePublicKey = parsePublicKey;
function parseSignature(buf) {
    const { result } = (0, asn1js_1.fromBER)(toArrayBuffer(buf));
    const values = result.valueBlock.value;
    const getHex = (value) => {
        const buf = Buffer.from(value.valueBlock.valueHex);
        return buf.slice(Math.max(buf.length - 32, 0));
    };
    const r = getHex(values[0]);
    const s = getHex(values[1]);
    return { r, s };
}
exports.parseSignature = parseSignature;
//# sourceMappingURL=asn1-parser.js.map