import { Signer } from './signer';
import { KMSClientConfig } from '@aws-sdk/client-kms';
declare class KmsAuthorizer {
    private readonly signer;
    constructor(kmsOptions: KMSClientConfig, keyIdOrKeyIds: string | string[]);
    getSigner(): Signer;
    getPublicKey(): Promise<string>;
    getFlowPublicKey(signatureAlgorithm?: number, // ECDSA_secp256k1
    hashAlgorithm?: number, // SHA3-256
    weights?: number[]): Promise<string>;
    authorize(fromAddress: string, keyIndexOrKeyIndexes: number | number[]): any | any[];
    private getAccount;
}
export { KmsAuthorizer, Signer };
