import { KMSClientConfig } from '@aws-sdk/client-kms';
export declare class Signer {
    private readonly kms;
    private readonly keyIds;
    constructor(kmsOptions: KMSClientConfig, keyIds: string[]);
    sign(message: string, index?: number): Promise<string>;
    signUserMessage(message: string, index?: number, // index is the index of the keyIds array, not keyIndex
    userTag?: string): Promise<string>;
    getPublicKey(): Promise<string>;
    getFlowPublicKey(signatureAlgorithm?: number, // ECDSA_secp256k1
    hashAlgorithm?: number, // SHA3-256
    weights?: number[]): Promise<string>;
    private _hashMessage;
    private _hashMessageWithUserTag;
    private _toBytesWithTag;
    private _getPublicKey;
    private _sign;
    private _pad32;
}
